package dev.shadowsoffire.apotheosis.adventure.event;

import net.minecraft.world.item.ItemStack;
import net.minecraftforge.eventbus.api.Event;

public abstract class ItemSocketingEvent extends Event
{
    protected final ItemStack stack;
    protected final ItemStack gem;
    
    public ItemSocketingEvent(final ItemStack stack, final ItemStack gem) {
        this.stack = stack.m_41777_();
        this.gem = gem.m_41777_();
    }
    
    public ItemStack getInputStack() {
        return this.stack;
    }
    
    public ItemStack getInputGem() {
        return this.gem;
    }
    
    @Event.HasResult
    public static class CanSocket extends ItemSocketingEvent
    {
        public CanSocket(final ItemStack inputStack, final ItemStack inputGem) {
            super(inputStack, inputGem);
        }
    }
    
    public static class ModifyResult extends ItemSocketingEvent
    {
        protected ItemStack output;
        
        public ModifyResult(final ItemStack stack, final ItemStack gem, final ItemStack output) {
            super(stack, gem);
            this.output = output;
        }
        
        public ItemStack getOutput() {
            return this.output;
        }
        
        public void setOutput(final ItemStack output) {
            if (output.m_41619_()) {
                throw new IllegalArgumentException("Setting an empty output is undefined behavior");
            }
            this.output = output;
        }
    }
}
